<html>
<head>
<meta name="description" content="Programs and source for the cybiko handheld computer">
<meta name="keywords" content="cybiko,programs,source,tutorial">
<link rel="stylesheet" type="text/css" HREF="../main.css">
</head>
<body>
<?php include("header.htm")?>
<u><big>Bouncing Ball</big></u>
<p>
This program loads a sprite resource and bounces it arround the cybiko display. Direct keyboard is also used
to allow the user to exit the program by pressing the space bar. The sprite is a 16x16 pic file that is put
in the 'res' folder and then gets included in the actual app.
</p>
<p>
You can download the app + source using the link below.
</p>
<p>
<a href="ball.zip">Download now</a>
</p>
<p>
<i>If you have any comments about this tutorial, please use the <a href="http://cybiko.us">DevCybiko</a> /
<a href="http://planetcybiko.net/">PlanetCybiko</a> forums or personal messaging
and let me know!</i>
</p>

<u><big>What you will need</big></u>
<p>
The Cybiko SDK<br>
</p>
<u><big>The program</big></u><br>
<b>Note: </b>Don't type in the line numbers!

<pre>
<font color='red'>1</font> <font color='green'>//</font>
<font color='red'>2</font> <font color='green'>// Bouncing Ball by ssjx (7/8/6)</font>
<font color='red'>3</font> <font color='green'>//</font>
<font color='red'>4</font> <font color='green'></font>
<font color='red'>5</font> <font color='green'>#include &lt;cybiko.h&gt;</font>
<font color='red'>6</font> <font color='green'></font>
<font color='red'>7</font> <font color='green'>struct module_t main_module;</font>
<font color='red'>8</font> <font color='green'>struct DirectKeyboard* ptr_direct_keyboard;</font>
<font color='red'>9</font> <font color='green'>struct Bitmap bmp;</font>
<font color='red'>10</font> <font color='green'></font>
<font color='red'>11</font> <font color='green'>long main(int argc, char *argv[],bool start)</font>
<font color='red'>12</font> <font color='green'>{</font>
<font color='red'>13</font> <font color='green'>int x,y,xdir=1,ydir=1,h,w,ext=0;</font>
<font color='red'>14</font> <font color='green'></font>
<font color='red'>15</font> <font color='green'>init_module(&amp;main_module);</font>
<font color='red'>16</font> <font color='green'></font>
<font color='red'>17</font> <font color='green'>ptr_direct_keyboard = DirectKeyboard_get_instance();</font>
<font color='red'>18</font> <font color='green'></font>
<font color='red'>19</font> <font color='green'>x=20+random(120);</font>
<font color='red'>20</font> <font color='green'>y=20+random(60);</font>
<font color='red'>21</font> <font color='green'></font>
<font color='red'>22</font> <font color='green'>TRACE("Loading sprite");</font>
<font color='red'>23</font> <font color='green'>Bitmap_ctor_Ex1( &amp;bmp,"ball.pic" );</font>
<font color='red'>24</font> <font color='green'></font>
<font color='red'>25</font> <font color='green'>h=Bitmap_get_h(&amp;bmp);</font>
<font color='red'>26</font> <font color='green'>w=Bitmap_get_w(&amp;bmp);</font>
<font color='red'>27</font> <font color='green'>TRACE("Sprite is %d x %d in size",w,h);</font>
<font color='red'>28</font> <font color='green'></font>
<font color='red'>29</font> <font color='green'>TRACE("Starting..");</font>
<font color='red'>30</font> <font color='green'></font>
<font color='red'>31</font> <font color='green'>while(ext==0)</font>
<font color='red'>32</font> <font color='green'>{</font>
<font color='red'>33</font> <font color='green'>TGraph_fill_screen( main_module.m_gfx, CLR_WHITE );</font>
<font color='red'>34</font> <font color='green'>Graphics_draw_bitmap( main_module.m_gfx, &amp;bmp, x, y, BM_NORMAL );</font>
<font color='red'>35</font> <font color='green'>DisplayGraphics_show(main_module.m_gfx );</font>
<font color='red'>36</font> <font color='green'></font>
<font color='red'>37</font> <font color='green'>x+=xdir;</font>
<font color='red'>38</font> <font color='green'>y+=ydir;</font>
<font color='red'>39</font> <font color='green'></font>
<font color='red'>40</font> <font color='green'>if ( (x+w)==160){xdir=-xdir;}</font>
<font color='red'>41</font> <font color='green'>if ( (y+h)==100){ydir=-ydir;}</font>
<font color='red'>42</font> <font color='green'>if (x==0){xdir=-xdir;}</font>
<font color='red'>43</font> <font color='green'>if (y==0){ydir=-ydir;}</font>
<font color='red'>44</font> <font color='green'></font>
<font color='red'>45</font> <font color='green'>if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_SPACE ) ){ext=1;}</font>
<font color='red'>46</font> <font color='green'>}</font>
<font color='red'>47</font> <font color='green'></font>
<font color='red'>48</font> <font color='green'>TRACE("Finished");</font>
<font color='red'>49</font> <font color='green'></font>
<font color='red'>50</font> <font color='green'>DirectKeyboard_dtor( ptr_direct_keyboard, FREE_MEMORY );</font>
<font color='red'>51</font> <font color='green'>Bitmap_dtor( &amp;bmp, LEAVE_MEMORY );</font>
<font color='red'>52</font> <font color='green'>return 0L;</font>
<font color='red'>53</font> <font color='green'>}</font>
</pre>


<u><big>How it works</big></u>
<p>
<table>
<tr valign="top">
<tr>
<td width=60><b>Line(s)
<td>

<tr>
<td width=60>5
<td>The standard cybiko include and main module required by most cybiko programs.

<tr valign="top">
<td>7-9
<td>The main module struct is almost always required, and as we are using bitmaps (sprites) and the keyboard, they
also need structs to hold data in.

<tr valign="top">
<td>13
<td>Our variables, these will hold the position, direction and size of our sprite ball.

<tr valign="top">
<td>15
<td>Initialises the main_module struct.

<tr valign="top">
<td>17
<td>Allows us to use the DirectKeyboard functions to read the keyboard.

<tr valign="top">
<td>19-20
<td>Give the sprite a random start postion.

<tr valign="top">
<td>22-27
<td>Load our sprite which was included in our app into the bitmap stuct and then get its dimensions.

<tr valign="top">
<td>31 
<td>The start of our sprite bounce loop.

<tr valign="top">
<td>33-35
<td>These lines handle the sprite movement. This is done by clearing the screen, drawing the ball at its new postion
and then displaying everything. If you wanted to slow it down to lessen the motion blurring, a sleep() could be inserted
after the _show() function.

<tr valign="top">
<td>37-38
<td>Change the position of the sprite ball. Remember, the sprite does not actually move until it the loop gets to
lines 33-35.

<tr valign="top">
<td>40-43
<td>These lines change the direction of the sprite if it reaches the edge of the screen. The sprites origin point is the
top left so we need to add its width to check if it has hit something on the right. The height needs to be added to check
the bottom of the sprite. The direct is changed by changing the direction values sign, e.g. 1 (right) becomes -1 (left).  

<tr valign="top">
<td>45
<td>Check to see if the space key has been press, if so set our exit variable so we can leave the loop. This loop could
just as easily checked for an exit at the end using 'do{}while(ext==0);'.

<tr valign="top">
<td>50-53
<td>Tidy up by deleting our bitmap and keyboard objects, then exit our program.

</table>
<p>&nbsp;</p>
<p>&nbsp;</p>

<?php include("footer.htm")?>
</body>
</html>
